 /*
'MONTE CARLO FARM PLANNING METHOD
'
' ECONOMICS DEPARTMENT, WYE COLLEGE (UNIVERSITY OF LONDON)
' RMD 1967
'
' ADAPTED BY PODERICO LUIGI, 1995
*/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

#define TRUE 1
#define FALSE 0
/* #define TEST */

FILE* selectinput(int argc, char *argv[]) {

	FILE* in;

	if (argc==0)
		in=stdin;
	else
		if ((in=fopen(argv[1],"rt"))==NULL) {
			printf("Errore nell'apertura del file\n");
			exit(EXIT_FAILURE);
			};
	return(in);
}

int main(int argc,char *argv[])
{
	float a[66][66], d[33][99], z[170][20], min[66], max[66], gm[66];
	float e[66], e1[66], c[66], f[66], dal[33], kx[66], dasell[33];
	int ky[50];
	float dabuy[33], w[170][20], iw[170][20];
	int itns, it, finito;
	int tentativi,s_accettabile;
	#define MAXT 1000
	int n1, n2, m1, m2, l, lmin, lmax, m, n, maxno;
	int i, j, /*last,*/ k;
	float kxinit, kxmin, kb;
	/* int ix, iy; */
	float yfl, diff, level, xlev, x, xmin;
	float gmra, das, dab, zmax, tgm, tgmmin;
	FILE* in;
	time_t t;

	in=selectinput(argc,argv);

	/* LEGGE IL NUMERO DI ITERAZIONI */
	fscanf(in,"%i" ,&itns);
	/* clrscr(); */
	#ifdef TEST
		printf("Stampa dei dati\n");
		printf("Numero di iterazioni:%d\n",itns);
	#endif

	/* legge il numero delle attivit e il numero delle attivit selezionabili */
	fscanf(in,"%d", &n1);
	n2=n1;
	#ifdef TEST
		printf("Attivit totali:        %d\n",n1);
		printf("Attivit selezionabili: %d\n",n2);
	#endif

	/* Legge il massimo numero di attivit in progetto */
	fscanf(in,"%d", &maxno);
	#ifdef TEST
		printf("Massimo numero di attivit: %d\n", maxno);
	#endif

	/* legge il numero di attivit derivate e il numero di vincoli */
	fscanf(in,"%d %d", &m2, &m1);
	#ifdef TEST
		printf("Vincoli:           %d\n",m1);
		printf("Attivit derivate: %d\n",m2);
	#endif
	/*Azzera la matrice A*/
	for (i=0; i<m1; i++)
		for (j=0; j<n2; j++)
			a[i][j]=0;

	/* Sottointestazione per la stampa */
	#ifdef TEST
		printf ("Coefficienti della matrice A\n");
	#endif
	/* Legge i coefficienti della matrice A 1 per riga */
	for (i=0;i<m1;i++)
		for (j=0;j<n2;j++) {
			fscanf(in,"%f",&x);
			a[i][j]=x;
			#ifdef TEST
				printf("%d %d %f\n", i, j, x);
			#endif
			}

	/* Legge i margini lordi 8 per riga */
	for (j=0;j<n2;j++)
		fscanf(in,"%f", &gm[j]);
	#ifdef TEST
		printf("Margini lordi\n");
		for (j=0;j<n2;j++) {
			printf("%f ", gm[j]);
			if (j+1%8==0 || j==n2-1)
				printf("\n");
			}
	#endif

	/*Legge i vincoli 8 per riga*/
	for (i=0;i<m1;i++)
		fscanf(in,"%f", &c[i]);
	#ifdef TEST
		printf("Vincoli:\n");
		for (i=0;i<m1;i++) {
			printf("%f ", c[i]);
			if (j+1%8==0 || i==m1-1)
				printf("\n");
			}
	#endif

	/*Legge i pesi cumulativi 8 per riga */
	for (j=0;j<n2;j++) {
		fscanf(in,"%f", &x);
		e1[j]=100-((x<0?0:x)>100?100:x);
		}
	#ifdef TEST
		printf("Pesi cumulativi\n");
		for (j=0;j<n2;j++) {
			printf ("%f ", e1[j]);
			if (j+1%8==0 || j==n2-1)
				printf("\n");
			}
	#endif

	/*Legge il minimo per le attivit 8 per riga*/
	for (j=0;j<n2;j++)
		fscanf(in,"%f", &min[j]);
	#ifdef TEST
		printf("Minimo per le attivit\n");
		for (j=0;j<n2;j++) {
			printf("%f ", min[j]);
			if (j+1%8==0 || j==n2-1)
				printf("\n");
			}
	#endif

	/*Legge il massimo per le attivit 8 per riga*/
	for (j=0;j<n2;j++)
		fscanf(in,"%f", &max[j]);
	#ifdef TEST
		printf("Massimo per le attivit\n");
		for (j=0;j<n2;j++) {
			printf("%f ", max[j]);
			if (j+1%8==0 || j==n2-1)
				printf("\n");
			}
	#endif

	/* Se non ci sono attivit derivata salto la lettura della matrice D */
	if (m2) {
		/* Cancella la matrice D */
		for (i=0;i<m2;i++)
			for (j=0;j<n1;j++) {
				fscanf(in,"%f",&x);
				d[i][j]=x;
				}

		#ifdef TEST
			printf("Stampa dei coefficienti della matrice D\n");
			for (i=0;i<m2;i++)
				for (j=0;j<n1;j++)
					printf("%d %d %f\n", i, j, d[i][j]);
		#endif
		/*Legge il prezzo d'acquisto delle attivit derivate*/
		for(j=0;j<m2;j++)
			fscanf(in,"%f", &dabuy[j]);
		#ifdef TEST
			printf("Attivit derivate: prezzo d'acquisto\n");
			for (j=0;j<m2;j++) {
				printf("%f ", dabuy[j]);
				if (j+1%8==0 || j==m2-1)
					printf("\n");
				}
		#endif

		/* Legge il prezzo di vendita delle attivit derivate */
		for (j=0;j<m2;j++)
			fscanf(in,"%f", &dasell[j]);
		#ifdef TEST
			printf("Attivit derivate: prezzo di vendita\n");
			for (j=0;j<m2;j++) {
				printf("%f ", dasell[j]);
				if (j+1%8==0 || j==m2-1)
					printf("\n");
				}
		#endif
		};

/********************************************************************/

	/* Elaborazione dei dati */
	srand((unsigned) time(&t));
	m=1+m1+m2+n2;
	for (it=0;it<itns;it++) {
		for (j=0;j<n2;j++)
			max[j]++;
		tentativi=0;
		do {
			s_accettabile=TRUE;
			/* Inizializzazione iterazione corrente */
			k=0;
			for (j=0;j<n2;j++) {
				kx[j]=0;
				e[j]=e1[j];
				}
			for (i=0;i<m1;i++)
				f[i]=c[i];

			/* Seleziona una attivit e la inizializza */
			do {
				do {
					yfl=rand()/(float)RAND_MAX;
					yfl*=100;
					#ifdef TEST
						printf("*");
					#endif
					j=i=rand()%n2;
					while (e[j]>yfl && j<n2)
						j++;
					if (j==n2) {
						j=0;
						while (e[j]>yfl && j<i)
							j++;
						}
					}
				while ((e[j]>yfl)?TRUE:(kx[j]!=0));
						/* (kx[j]!=0 || j>=n2); */
				#ifdef TEST
					printf("-*\n");
				#endif
				e[j]=100;
				yfl/=100;
				diff=max[j]-min[j];
				level=yfl*diff;
				xlev=level+min[j];
				ky[k]=j;
				/**************************************************/
				#ifdef TEST
					printf("j=%d xlev=%f -- k=%d ky[k]=%d\n" ,j ,xlev ,k  ,ky[k]);
				#endif
				/**************************************************/
				k++;

				/*il livello  accettabile? */
				level=xlev;
				finito=FALSE;
				if (gm[j]>0.0)
					for (i=0;i<m1;i++) {
						#ifdef TEST
							printf("+");
						#endif
						if (a[i][j]!=0.0)
							if (f[i]<(xlev*a[i][j])) {
								xlev=f[i]/a[i][j]+0.000001;
								level=xlev;
								if (min[j]>level)
									finito=TRUE;
								}
						if (finito)
							break;
						}
				if (!finito) {
					xlev=level;
					if (level==0)
						kx[j]=-1;
					else {
						for (i=0;i<m1;i++) {
							f[i]-=xlev*a[i][j];
							if (f[i]<0.000001)
								f[i]=0;
							}
						kx[j]=level;
						}
					}
				else {
					kx[j]=-1;
					s_accettabile=FALSE;
					if (tentativi++>MAXT) {
						printf("Problema inammissibile!!!!!!!\n");
						/* exit(EXIT_FAILURE);*/
						return 1;
						}
					}
				/**************************************************/
				#ifdef TEST
					printf("kx[j]=%f - ",kx[j]);
				#endif
				/**************************************************/
				}
			while (k<maxno && s_accettabile);
			}
		while (!s_accettabile);

		/* Livelli finali */
		for (j=0;j<n2;j++)
			max[j]-=1;
		for (k=0;k<maxno;k++) {
			j=ky[k];
			if (kx[j]>0 && gm[j]>0.0) {
				kxinit=kx[j];

				/* Espande le attivit al limite della pi piccola risorsa
					rimanente */
				kxmin=100000.0;
				finito=FALSE;
				for (i=0;i<m1;i++) {
					if (a[i][j]>0) {
						kb=f[i]/a[i][j]+0.000001;
						if (kb<=1)
							finito=TRUE;
						if (finito)
							break;
						if (kb<=kxmin)
							kxmin=kb;
						}
					if (finito)
						break;
					};
				if (finito)
					kxmin=0;
				kx[j]+=kxmin;
				/*************************************************
				printf("j=%d kx[j]=%f\n",j,kx[j]);
				*************************************************/
				if (max[j]<kx[j]) {
					kxmin=max[j]-kxinit;
					kx[j]=max[j];
					}
				/* Ricalcola le risorse rimanenti */
				xmin=kxmin;
				for (i=0;i<m1;i++)
					f[i]-=xmin*a[i][j];
				}
			}
		/********************************************************/
		#ifdef TEST
			printf("\n\nStampa delle soluzione corrente:\n");
			printf("Iterazione %d, costo %f\n",it,tgm);
			for (j=0;j<n2;j++)
					printf("%f ",kx[j]);
			printf("\n");
		#endif
		/********************************************************/

		/* Calcola il margine totale lordo */
		if (m2!=0)
			for (i=0;i<m2;i++)
				dal[i]=0;
		/* Totale attivit primarie */
		gmra=0.0;
		for (k=0;k<maxno;k++) {
			j=ky[k];
			if (kx[j]>0) {
				x=kx[j];
				if (m2!=0)
					for (i=0;i<m2;i++)
						dal[i]+=x*d[i][j];
				gmra+=x*gm[j];
				}
			}
		/* Totale attivit derivate */
		das=0.0;
		dab=0.0;
		if (m2!=0)
			for (i=0;i<m2;i++) {
				l=n2+1;
				j=l;
				/* while (d[i][j]!=-1.0)
					j++; */
				if (dal[i]>0.0)
					das+=dal[i]*dasell[i];
				else
					dab+=dal[i]*dabuy[i];
				}
		tgm=gmra-dab-das;

		/********************************************************
		printf("\n\nStampa delle soluzione corrente:\n");
		printf("Iterazione %d, costo %f\n",it,tgm);
		for (j=0;j<n2;j++) 
				printf("%f ",kx[j]);
		printf("\n");
		printf("Vincoli:\n");
		for (j=0;j<m1;j++)
			printf("%f ",f[j]);
		printf("\n");
		********************************************************/

		/* Seleziona le prime venti */
		if (it<20 || tgm>tgmmin) {
			if (it<20)
				l=it;
			else
				l=lmin;
			/* Memorizza il margine lordo totale */
			z[0][l]=tgm;
			for (i=1;i<m;i++)
				z[i][l]=0.0;
			/* Memorizza attivit e livelli */
			i=1;
			for (j=0;j<n2;j++) {
				if (kx[j]>0.0)
					z[i][l]=kx[j];
				i++;
				}
			/* Memorizza le attivit derivate */
			if (m2!=0.0)
				for (j=0;j<m2;j++) {
					z[i][l]=dal[j];
					i++;
					}
			/* Memorizza i vincoli rimasti */
			for (j=0;j<m1;j++) {
				z[i][l]=f[j];
				i++;
				}
			if (it>18) {
				tgmmin=z[0][0];
				lmin=0;
				for (k=1;k<20;k++)
					if (tgmmin>=z[0][k]) {
						tgmmin=z[0][k];
						lmin=k;
						}
				}
			}
		} /* Next it */
	/* Ordina i piani per il margine lordo totale */
	for (i=0;i<20;i++) {
		zmax=z[0][0];
		lmax=0;
		for (k=1;k<20;k++)
			if (zmax<z[0][k]) {
				zmax=z[0][k];
				lmax=k;
				}
		for (j=0;j<m;j++) {
			w[j][i]=z[j][lmax];
			z[j][lmax]=0.0;
			}
		}
 
	/* Stampa i risultati */
	printf("Tabella dei migliori 20 piani\n");
	l=0;
	k=10;
	do {
		for (j=l;j<k;j++)
			ky[j]=j;
		printf("\nPiano n.\t");
		for (j=l;j<k;j++)
			printf ("%9d\t",(int) ky[j]);
		printf("\n");
		printf("\nT.G.M.\t");
		for (j=l;j<k;j++)
			printf("%9.2f\t",w[0][j]);
		printf("\n");
		printf("\nAttivit\n");
		i=1;
		for (n=0;n<n2;n++) {
			for (j=l;j<k;j++)
				iw[i][j]=w[i][j];
			printf("%9d\t",n);
			for (j=l;j<k;j++)
				printf("%9.2f\t",iw[i][j]);
			i++;
			printf("\n");
			}
		if (m2!=0) {
			printf("\nAttivit derivate (segno + = Vendita, segno - = Costo o comprato)\n");
			for (n=0;n<m2;n++) {
				for (j=l;j<k;j++)
					w[i][j]=-w[i][j];
				printf("%d\t",n);
					for (j=l;j<k;j++)
					printf ("%9.2f\t",w[i][j]);
				printf("\n");
				i++;
				}
			}
		printf("\nVincoli rimanenti\n");
		for (n=0;n<m1;n++) {
			printf("%9d\t",n);
			for (j=l;j<k;j++)
				printf("%9.2f\t",w[i][j]);
			printf ("\n");
			i++;
			}
		if (k==20)
			break;
			l=10;
			k=20;
			printf("\n");
		} while (1);
		return 0;
};
